/*-
 * ~~~~~~licensing~~~~~~
 * profile-manager
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.management.profile.manager;

import ru.entaxy.esb.system.management.bundle.jpa.dto.BundleDto;
import ru.entaxy.esb.system.management.profile.manager.dto.ProfileDto;

import java.util.List;

public interface ProfileManager {

    BundleDto installProfile(ProfileDto profileDto) throws Exception;

    BundleDto startProfile(ProfileDto profileDto) throws Exception;

    BundleDto stopProfile(ProfileDto profileDto) throws Exception;

    ProfileDto getProfile(ProfileDto profileDto) throws Exception;

    List<ProfileDto> getProfiles() throws Exception;

    List<ProfileDto> getPermissionsBySubject(String uuid) throws Exception;

    List<ProfileDto> getPermissionsByObject(String uuid) throws Exception;

    void uninstallProfile(ProfileDto profileDto) throws Exception;

    void restore() throws Exception;
}
